100 remark +------------------------------------------------------------+
110 remark |     QL IRC by Timothy Swenson & Dilwyn Jones, 2019/20      |
120 remark +------------------------------------------------------------+
130 :
140 remark program version and name
150 version$ = "1.99.9"
160 progname$ = "QLirc"
170 :
180 remark +------------------------------------------------------------+
190 remark |   Configuration data, colours, and initialisation block    |
200 remark +------------------------------------------------------------+
210 chat_ink1%       = 4 : remark normal chat text colour
220 chat_ink2%       = 7 : remark names highlight colour
230 chat_ink3%       = 2 : remark NOTICEs and other highlighted text
240 chat_paper%      = 0
250 chat_border%     = 4
260 splash_ink%      = 2 : remark colour of opening logo within chat window
270 :
280 input_ink%       = 7
290 input_highlight% = 4
300 input_paper%     = 0
310 input_border%    = 2
320 :
330 list_ink%        = 4
340 list_highlight%  = 2
350 list_paper%      = 0
360 list_border%     = 4
370 :
380 title_ink%       = 0
390 title_paper%     = 4
400 title_border%    = 4
410 :
420 highlight_sound% = 1 : remark 1=beep if own nickname detected in a message
430 :
440 ox%              = 0 : remark origin co-ordinates
450 oy%              = 0
460 :
470 beep_on_message% = 0
480 beep_durtn%      = 100
490 beep_pitch%      = 10
500 :
510 remark the next line configures whether to apply a "fix" for when QL Forum
520 remark IRC is working with the QL-Bot on Discord channel, whereby the
530 remark anti-looping systems adds a UTF character in the sender name in the
540 remark message part where <name> becomes <n^^^ame> as far as QL irc is
550 remark concerned (it does no harm, just looks unsightly in conversations).
560 remark Works by identifying QL-Bot as the sender, then removing characters
570 remark 3+4+5 from the name displayed. A bodge, if you like, until QLirc
580 remark does UTF8.
590 QL_Bot_adjust    = 1 : remark 1=remove anti-looping UTF characters from name
600 :
610 remark log everything to this file (""=don't log)
620 logfile$         = "ram1_log_txt"
630 password$        = "" : remark in case QLForum IRC ever needs a password
640 server$          = "irc.mibbit.net" : remark name of server to connect to
650 realname$        = "QLirc" : remark RealName field in USER command
660 forum$           = "#QLforum" : remark name of channel to join
670 remark +------------------------------------------------------------+
680 remark |   End of configuration data                                |
690 remark +------------------------------------------------------------+
700 :
710 tcp_chan%   = -1 : remark this will be used for a TCP channel number
720 crlf$       = chr$(13) & chr$(10) : remark TCP channel lines end with CR+LF
730 last_entry$ = "" : remark used to record previous entry from user.
740 query_mode% = 0  : remark 0=not in private messaging mode (1=in that mode)
750 :
760 remark up to 30 users, nicknames up to 9 characters long (RFC 2812)
770 remark although longer names allowed by modern servers. ustat$() is
780 remark the user or nickname status prefix
790 remark ~(owner) &(admin) AT(full operator) %(half operator) +(voiced user)
800 max_users% = 30
810 dim ustat$(max_users%-1,2),user$(max_users%-1,30)
820 users = 0 : remark how many users online (0 to users%-1 in the arrays)
830 :
840 remark +----------------------------------------------------------+
850 remark | open the main windows                                    |
860 remark | chat_chan%,input_chan%,list_chan%=#4,#5,#6 in v1.00      |
870 remark +----------------------------------------------------------+
880 Screen_Size : remark get screen sizes to make sure origin not out of range
890 if ox%+512 > wide% then ox% = wide%-512
900 if oy%+256 > high% then oy% = high%-256
910 :
920 sc$ = "scr_424x232a"&ox%&"x"&(oy%+12)
930 chat_chan%  = FOPEN(sc$)
940 :
950 sc$ = "con_512x12a"&ox%&"x"&(oy%+244)
960 input_chan% = FOPEN(sc$)
970 :
980 sc$ = "scr_88x232a"&(ox%+424)&"x"&(oy%+12)
990 list_chan% = FOPEN(sc$)
1000 :
1010 sc$ = "scr_512x12a"&ox%&"x"&oy%
1020 title_chan% = FOPEN(sc$)
1030 :
1040 Draw_Display
1050 :
1060 remark +---------------------------------------------------------+
1070 remark | Opening Splash Screen                                   |
1080 remark +---------------------------------------------------------+
1090 over #chat_chan%,1
1100 csize #chat_chan%,3,1
1110 ink #chat_chan%,chat_ink1%
1120 sc$ = progname$&" "&version$
1130 for x = 1 to 5
1140   cursor #chat_chan%,((400-(16*len(sc$))) div 2)+(2*x),40+(2*x)
1150   print #chat_chan%,progname$&" v";version$
1160 end for x
1170 ink #chat_chan%,splash_ink%
1180 cursor #chat_chan%,((400-(16*len(sc$))) div 2)+10,50
1190 print #chat_chan%,progname$&" v";version$
1200 ink #chat_chan%,chat_ink1%
1210 :
1220 csize #chat_chan%,0,0
1230 ink #chat_chan%,chat_ink1%
1240 print #chat_chan%,
1250 print #chat_chan%,to 19;"Simple Internet Relay Chat Client"
1260 print #chat_chan%,to 23;"For Sinclair QL Emulators"
1270 print #chat_chan%," "
1280 :
1290 remark +--------------------------------------------------------+
1300 remark | Open Log file if logging the session                   |
1310 remark +--------------------------------------------------------+
1320 log% = 0 : remark are we logging everything to file?
1330 log_chan% = -1 : remark number of Log channel when opened
1340 if logfile$ > "" then
1350   log_chan% = fop_over(logfile$)
1360   if log_chan% < 0 then report log_chan% : stop
1370   log% = 1 : rem write everything to file
1380   print #log_chan%,"IRC Session Log From ";progname$;" ";version$;" On ";date$
1390   print #log_chan%,
1400 end if
1410 :
1420 remark the main program loop starts here, e.g. after a /quit it goes
1430 remark back to here
1440 last_pm_name$ = "" : query_mode% = 0 : remark new channel, reset query mode
1450 :
1460 remark +--------------------------------------------------------+
1470 remark | Enter opening details.                                 |
1480 remark | Program can restart here after a /quit, for example    |
1490 remark | Start by entering IRC nickname                         |
1500 remark +--------------------------------------------------------+
1510 print #input_chan%,"Enter IRC Name/Handle: ";
1520 input #input_chan%,my_name$
1530 if my_name$ = "" then
1540   remark close everything down
1550   close # list_chan% : close #input_chan% : close #chat_chan%
1560   if log% then close #log_chan%
1570   if tcp_chan% >= 0 then close #tcp_chan%
1580   stop
1590 end if
1600 :
1610 remark check validity of nickname entered
1620 remark my_name$ should not contain NUL/LF/CR/At symbol/Space
1630 ok% = 1 : rem assume OK until proven otherwise
1640 for i = 1 to len(my_name$)
1650   c = code(my_name$(i))
1660   sel on c = 0,10,13,32,64 : ok% = 0 : exit i
1670 end for i
1680 if ok% = 0 then
1690   print #chat_chan%,"ERROR:"&my_name$&" is an invalid nickname."
1700   Log "ERROR:"&my_name$&" is an invalid nickname ["&date$&"]"
1710   goto 1440
1720 end if
1730 :
1740 cls #input_chan%
1750 :
1760 remark +--------------------------------------------------------+
1770 remark | Open Channel to IRC server                             |
1780 remark +--------------------------------------------------------+
1790 print #chat_chan%,"Connecting channel "&forum$&" via server "&server$
1800 Log "Connecting to channel "&forum$&" via server "&server$&":6667 ["&date$&"]"
1810 tcp_chan% = FOP_IN("tcp_"&server$&":6667")
1820 if tcp_chan% < 0 then
1830   remark failed to open the channel to the IRC server
1840   report #chat_chan%,tcp_chan%
1850   pause 200 : remark viewing pause before closing windows
1860   close #list_chan% : close #input_chan% : close #chat_chan%
1870   stop
1880 end if
1890 Log "tcp_"&server$&":6667 opened "&date$
1900 :
1910 remark Get two lines in response from the IRC server
1920 remark first is looking up hostname message
1930 remark second is result message.
1940 remark connection failure may result in an ERROR command from server
1950 :
1960 remark 1. Hope to receive a "looking up hostname" message
1970 INPUT #tcp_chan%,in$ : in$ = Uncr$(in$)
1980 Log ">"&in$
1990 rem was there an error while trying to connect (e.g. timeout)?
2000 if ("ERROR" instr in$) = 1 then
2010   remark Oops...
2020   print #chat_chan%,in$ : Log in$
2030   goto 1440
2040 end if
2050 :
2060 remark 2. result message
2070 INPUT #tcp_chan%,in$ : in$ = Uncr$(in$)
2080 Log ">"&in$
2090 :
2100 remark +--------------------------------------------------------+
2110 remark | Handle the PASSword if required by this channel        |
2120 remark +--------------------------------------------------------+
2130 if password$ <> "" then
2140   PRINT #chat_chan%,"PASS "&password$;crlf$;
2150   Log "> PASS "&fill$("*",len(password$))
2160 end if
2170 :
2180 remark +--------------------------------------------------------+
2190 remark | Handle the USER name                                   |
2200 remark +--------------------------------------------------------+
2210 PRINT #tcp_chan%,"USER "&my_name$&" 0 * :"&realname$&crlf$;
2220 Log "USER "&my_name$&" 0 * :real name"
2230 :
2240 remark +--------------------------------------------------------+
2250 remark | Handle the NICK name                                   |
2260 remark +--------------------------------------------------------+
2270 PRINT #tcp_chan%,"NICK "&my_name$&crlf$;
2280 Log "NICK "&my_name$
2290 :
2300 remark +--------------------------------------------------------+
2310 remark | expecting PING command request from server at this     |
2320 remark | stage or possibly an ERROR message from PASS/USER/NICK |
2330 remark | e.g.name in use(codes 461,462,431,432,433,436,437,489) |
2340 remark +--------------------------------------------------------+
2350 INPUT #tcp_chan%,in$ : remark response line from server
2360 Log ">"&in$
2370 in$ = Uncr$(in$)
2380 :
2390 remark which response did server send? Parse_Response procedure returns:
2400 remark   sender$    = sender's nickname if present
2410 remark   host$      = host name if present
2420 remark   command$   = command name or numeric code
2430 remark   parameter$ = parameters after command, may include nickname
2440 Parse_Response in$
2450 :
2460 a$ = command$
2470 if a$="461" or a$="462" or a$="431" or a$="432" or a$="433" or a$="436" or a$="437" or a$="484" then
2480   remark PASS, USER or NICK returned an error
2490   print #chat_chan%,command$&" "&parameter$
2500   Log command$&" "&parameter$
2510   goto 1440
2520 else
2530   remark is client being asked to acknowledge a PING command?
2540   if command$ == "PING" and (":" instr parameter$) then
2550     print #tcp_chan%,"PONG "&parameter$&crlf$;
2560     Log "PONG "&parameter$&" ["&date$&"]"
2570   end if
2580 end if
2590 :
2600 remark expecting a multi-line reply ending with MODE notice
2610 REPeat loop
2620   INPUT #tcp_chan%,in$
2630   Log ">"&in$
2640   x$ = my_name$&" MODE" : remark contained in last line
2650   IF (x$ INSTR in$) THEN EXIT loop
2660 END REPeat loop
2670 :
2680 Join_Channel : remark e.g. "JOIN #QLForum", and handle the replies
2690 :
2700 Log "<QLirc entering 'mainloop'>"
2710 :
2720 remark this is the main "chat" part of the program
2730 a$     = "" : remark user input character
2740 aa$    = "" : remark user input string
2750 b$     = "" : remark character read from IRC
2760 bb$    = "" : remark string received from IRC
2770 curpos = 0  : remark editing cursor position
2780 curx%  = 0  : remark first character shown-1 in input
2790 maxlen = 510: remark longest input allowed
2800 sx%    = 0  : remark start-x - first visible character of aa$ (starts at 0)
2810 ex%    = 0  : remark end-x - last visible character of aa$
2820 :
2830 cursen #input_chan% : remark switch on cursor in typing channel
2840 :
2850 repeat mainloop
2860   :
2870   remark +------------------------------------------------------------------+
2880   remark | OUTGOING MESSAGES - Get keyboard input from User                 |
2890   remark | User input window 504 pixel/84 characters wide (incl. cursor)    |
2900   remark +------------------------------------------------------------------+
2910   :
2920   a$ = inkey$(#input_chan%,1) : remark adjust delay as required.
2930   akey = code(a$)
2940   :
2950   if a$ <> "" then
2960     remark some key or other pressed
2970     sel on akey
2980       =10 : remark ENTER
2990         remark -------------------------------------------------
3000         remark ENTER pressed, check for /command entered by user
3010         remark and record as the last entry in last_entry$
3020         remark -------------------------------------------------
3030         last_entry$ = aa$
3040         if aa$ = "" then next mainloop
3050         :
3060         if code(aa$) = code('/') then
3070           remark lines starting with '/' are /commands
3080           :
3090           remark /AWAY or /BACK - indicate AWAY or BACK status
3100           remark /AWAY with no :message is same as /BACK
3110           if ("/away" instr aa$) = 1 or ("/back" instr aa$) = 1 then
3120             msg$ = "" : remark any message after the command
3130             spc = " " instr aa$ : remark message should follow space
3140             if spc = 0 or spc = len(aa$) then
3150               remark no message, equivalent to /back
3160               print #tcp_chan%,"AWAY"&crlf$;
3170 remark              ink #chat_chan%,chat_ink3%
3180               Wrap #chat_chan%,69,69,chat_ink3%,my_name$&" is back."
3190               ink #chat_chan%,chat_ink1%
3200               Log my_name$&" is back."
3210             else
3220               remark /away message
3230               msg$ = aa$(spc+1 to len(aa$))
3240               print #tcp_chan%,"AWAY :"&msg$&crlf$;
3250               Log "AWAY :"&msg$
3260 remark              ink #chat_chan%,chat_ink3%
3270               Wrap #chat_chan%,69,69,chat_ink3%,my_name$&" is away ("&msg$&")"
3280               Log my_name$&" is away ("&msg$&")"
3290             end if
3300           end if
3310           :
3320           remark /EXIT command exits the QLirc program
3330           if ("/exit" instr aa$) = 1 then
3340             remark exit from QLirc
3350 remark            ink #chat_chan%,chat_ink3%
3360         Wrap #chat_chan%,69,69,chat_ink3%,my_name$&" exited from program at "&date$
3370             Log "/exit:"&my_name$&" exited from program at "&date$
3380             last_pm_name$ = ""
3390             if query_mode% = 1 then query_mode% = 0 : Title
3400             exit mainloop : remark quit from program
3410           end if
3420           :
3430           remark /HELP command displays a list of the /COMMANDs
3440           if ("/help" instr aa$) = 1 then Help_Text
3450           :
3460           remark /JOIN #channel [key] = Join given channel, with optional key
3470           remark /JOIN 0 - leave all channels I'm currently a member of.
3480           if ("/join" instr aa$) = 1 then
3490             remark join channel(s)
3500             if len(aa$) = 5 then
3510               remark rejoin last channel
3520               Join_Channel
3530             else
3540               if aa$ == "/join 0" then
3550                 remark leave all connected channels
3560                 print #tcp_chan%,aa$(2 to len(aa$))&crlf$;
3570                 Log "JOIN 0"
3580               else
3590                 remark disconnect from existing channel
3600                 remark then join the new one specified
3610                 print #tcp_chan%,"PART "&forum$&crlf$;
3620                 Log "PART "&forum$
3630                 forum$ = Unspace$(aa$(6 to len(aa$)))
3640                 Join_Channel
3650               end if
3660             end if
3670           end if
3680           :
3690           remark /LIST [channel] [target_server]
3700           remark list channels (starting with given characters) and topics
3710           remark possible replies are:
3720           remark 322 RPL_LIST
3730           remark 323 RPL_LISTEND
3740           remark 402 RPL_NOSUCHSERVER
3750           remark 416 RPL_TOOMANYMATCHES
3760           if ("/list" instr aa$) = 1 then
3770             remark just drop the leading forward slash to send as-is
3780             print #tcp_chan%,aa$(2 to len(aa$))&crlf$;
3790             Log aa$(2 to len(aa$))
3800           end if
3810           :
3820           remark /LOG filename (no filename=stop logging)
3830           if ("/log" instr aa$) = 1 then
3840             remark turn session logging off (/log) or on (/log filename)
3850             parameter$ = "" : remark filename, if present
3860             if len(aa$) > 5 then
3870               if aa$(5) = " " then
3880                 remark there must be a space between /log and filename
3890                 remark close existing Log file
3900                 if log_chan% >= 0 then
3910                   close #log_chan% : log_chan% = -1 : log% = 0
3920                   Wrap #chat_chan%,69,69,cha_ink3%,"* Log file closed. *"
3930                   Log "* Log file closed ["&date$&"]"
3940                 end if
3950                 parameter$ = aa$(6 to len(aa$)) : remark new log file name
3960                 log_chan% = fop_over(parameter$)
3970                 if log_chan% < 0 then
3980                   remark failed to open the new log file
3990                   Wrap #chat_chan%,69,69,chat_ink3%,"* Failed to open new Log file at "&date$&" *"
4000                   log_chan% = -1 : log% = 0 : logfile$ = ""
4010                 else
4020                   log% = 1 : logfile$ = parameter$
4030                   Wrap #chat_chan%,69,69,chat_ink3%,"* Log file opened at "&date$&" *"
4040                   print #log_chan%,"IRC Session Log From ";progname$;
4050                   print #log_chan%," ";version$;" On ";date$
4060                   print #log_chan%
4070                 end if
4080               end if
4090             else
4100               remark just /log (no filename)
4110               if log% = 1 then
4120                 close #log_chan% : log% = 0 : log_chan% = -1
4130                 Wrap #chat_chan%,69,69,chat_ink3%,"* Log file closed ["&date$&"] *"
4140                 Log "* Log file closed ["&date$&"] *"
4150               end if
4160             end if
4170           end if
4180           :
4190           remark /ME - third person action (using CTCP ACTION)
4200           if ("/me" instr aa$) = 1 then
4210             remark NOTICE #QLForum :<$01>ACTION does something<$01>
4220             c$ = "PRIVMSG "&forum$&" :"&chr$(1)&"ACTION "
4230             if len(aa$) = 3 then
4240               remark empty messages should have space after ACTION according
4250               remark to CTCP specification
4260               c$ = c$ & " "
4270             else
4280               remark add the action text
4290               c$ = c$ & aa$(4 to len(aa$))
4300             end if
4310             c$ = c$&chr$(1)&crlf$
4320             print #tcp_chan%,c$; : Log c$
4330 remark            ink #chat_chan%,chat_ink3%
4340             Wrap #chat_chan%,69,69,chat_ink3%,my_name$&aa$(4 to len(aa$))
4350             ink #chat_chan%,chat_ink1%
4360             Log my_name$&aa$(4 to len(aa$))
4370           end if
4380           :
4390           if ("/mode " instr aa$) = 1 then
4400             remark change user mode or query/change channel characteristics
4410             remark /mode channel parameters
4420             remark /mode name usermodeparameters
4430             print #tcp_chan%,"MODE "&aa$(6 to len(aa$))&crlf$;
4440             Log "MODE "&aa$(6 to len(aa$))
4450           end if
4460           :
4470           if ("/move " instr aa$) = 1 then Move_Display
4480           :
4490           if ("/msg " instr aa$) = 1 then
4500             remark send private message to a user
4510             remark /MSG nickname :message_text
4520             remark /msg , :message_text sends PM to last person to PM me
4530             if len(aa$) > 5 then
4540               msg$ = Unspace$(aa$(6 to len(aa$)))
4550               spc = " " instr msg$ : remark split to nickname and message
4560               if spc > 0 then
4570                 user1$ = msg$(1 to spc-1)
4580                 remark a comma means reply to last person to PM me
4590                 if user1$ = "," then user1$ = last_pm_name$
4600                 msg$ = Unspace$(msg$(spc to len(msg$)))
4610                 if code(msg$) <> code(":") then msg$ = ":" & msg$
4620                 remark send as PRIVMSG with target name
4630                 print #tcp_chan%,"PRIVMSG "&user1$&" "&msg$&crlf$;
4640                 Log "PRIVMSG "&user1$&" "&msg$
4650                 last_pm_name$ = user1$
4660                 if query_mode% = 1 then query_mode% = 0 : Title
4670               end if
4680             end if
4690           end if
4700           :
4710           remark /NAMES channel - refreshes list of user names if required
4720           if ("/names" instr aa$) = 1 then
4730             remark clear the previous names list ready for new list.
4740             users = 0 : remark number of names in the list
4750             dim ustat$(max_users%-1,2),user$(max_users%-1,30) : remark users
4760             remark send NAMES command to server to request names list
4770             print #tcp_chan%,"NAMES "&forum$ : Log "/Names "&forum$
4780             remark arrays will be filled on receipt of 353/366 responses
4790             remark and names list redrawn after 353 and 366 processed
4800           end if
4810           :
4820           remark /NICK - change nickname to a new name
4830           remark to see if the name change was successful, check the response
4840           remark messages, which may be:
4850           remark oldname!host NICK :newname (if successful)
4860           remark 433 oldname newname :Nickname is already in use
4870           remark 431 ERR_NONICKNAMEGIVEN
4880           remark 432 ERR_ERRONEUSNICKNAME
4890           remark 436 ERR_NICKCOLLISION
4900           remark 437 ERR_UNAVAILRESOURCE
4910           remark 484 ERR_RESTRICTED
4920           if ("/nick " instr aa$) = 1 then
4930             if len(aa$) > 6 then
4940               new_name$ = aa$(7 to len(aa$)) : remark new nickname
4950               print #tcp_chan%,"NICK "&new_name$&crlf$; : Log "NICK "&new_name$
4960               remark check response from server before assigning new my_name$
4970               remark server will send back a NICK message if successful, or
4980               remark a numeric error code message listed above if unsuccessful
4990             end if
5000           end if
5010           :
5020           remark /OPER name password
5030           remark Obtain operator privileges (if you are entitled)
5040           remark upon success, the user will receive a MODE message to
5050           remark indicate the new user modes.
5060           remark possible replies are
5070           remark 461 ERR_NEEDMOREPARAMS
5080           remark 491 ERR_NOOPERHOST
5090           remark 464 ERR_PASSWDMISMATCH
5100           remark 381 RPL_YOUREOPER (i.e. success)
5110           if ("/OPER" instr aa$) = 1 then
5120             if len(aa$) > 6 then
5130               print #tcp_chan%,aa$(2 to len(aa$))&crlf$;
5140               Log aa$(2 to len(aa$))
5150             end if
5160           end if
5170           :
5180           remark /PART [channel] [:message] = depart from channel
5190           remark N.B. Not the same as /QUIT
5200           if ("/part" instr aa$) = 1 then
5210             rem DePART from a channel
5220             if aa$ == "/part" then
5230               remark PART from current channel
5240               print #tcp_chan%,"PART "&forum$&crlf$;
5250               Log "<PART "&forum$
5260             else
5270               remark PART from named channel, possibly with supplied message
5280               print #tcp_chan%,aa$(2 to len(aa$));crlf$;
5290               Log "<"&aa$
5300             end if
5310             last_pm_name$ = ""
5320             if query_mode% = 1 then query_mode% = 0 : Title
5330           end if
5340           :
5350           if ("/query" instr aa$) = 1 then
5360             remark /query names_list turns on private messaging to those names
5370             remark e.g. /query fred,joe    PMs those two users
5380             remark /query with no parameters resets the private messaging
5390             if len(aa$) > 6 then
5400               last_pm_name$ = Unspace$(aa$(7 to len(aa$)))
5410               query_mode% = 1
5420               print #chat_chan%,"Entering Query Mode (private messaging)with "&last_pm_name$
5430               print #chat_chan%,"Enter command '/QUERY' to leave Query Mode."
5440               Log "Entering Query Mode (private message) with "&last_pm_name$
5450               Log "Enter command '/QUERY' to leave Query Mode."
5460             else
5470               remark turn off query mode, including resetting window heading
5480               query_mode% = 0 : last_pm_name$ = ""
5490             end if
5500             Title : remark program name or query mode indication
5510           end if
5520           :
5530           remark /QUIT [message] = client session terminated
5540           remark (server will respond with ERROR message to client)
5550           remark N.B. not the same as /PART command
5560           if ("/quit" instr aa$) = 1 then
5570             print #tcp_chan%,aa$(2 to len(aa$))&crlf$;
5580             ink #chat_chan%,chat_ink2%
5590             print #chat_chan%,my_name$&": ";
5600 remark            ink #chat_chan%,chat_ink3%
5610             Wrap #chat_chan%,69-len(my_name$)-2,69,chat_ink3%,aa$
5620             ink #chat_chan%,chat_ink1%
5630             print #chat_chan%,my_name$&" has quit."
5640             Log my_name$&" has quit."
5650             remark the server should send an ERROR mesage acknowledgement
5660             input #tcp_chan%,msg$ : msg$ = Uncr$(msg$)
5670             if ("ERROR" instr msg$) = 1 then
5680               if len(msg$) > 5 then msg$ = Unspace$(msg$(6 to len(msg$)))
5690             end if
5700             print #chat_chan%,msg$ : Log msg$&' ['&date$&']'
5710             close #tcp_chan% : tcp_chan% = -1 : remark end session
5720             cls #input_chan%
5730             remark go back to the start (log file remains open)
5740             last_pm_name$ = ""
5750             if query_mode% = 1 then query_mode% = 0 : Title
5760             goto 1440
5770           end if
5780           :
5790           remark /TOPIC [#channel] [:message]
5800           if ("/TOPIC" instr aa$) = 1 then
5810             remark TOPIC #chan   = check topic for this channel
5820             remark TOPIC #chan : = clear topic for this channel
5830             remark TOPIC #chan :message  = set new topic for this channel if
5840             remark                         you have appropriate permissions.
5850             remark the channel name must be specified to read topic
5860             if aa$ == "/topic" then aa$ = aa$&" "&forum$
5870             print #tcp_chan%,aa$(2 to len(aa$))&crlf$;
5880             Log aa$(2 to len(aa$))
5890           end if
5900         else
5910           remark --------------------------------------------------
5920           remark not a command, it's a message to send to the Forum
5930           remark message format:     PRIVMSG #channel :message
5940           remark --------------------------------------------------
5950           if query_mode% = 0 then
5960             print #tcp_chan%,"PRIVMSG "&forum$&" :"&aa$&crlf$;
5970             Log "PRIVMSG "&forum$&" :"&aa$
5980           else
5990             print #tcp_chan%,"PRIVMSG "&last_pm_name$&" :"&aa$&crlf$;
6000             Log "PRIVMSG "&last_pm_name$&" :"&aa$
6010           end if
6020           ink #chat_chan%,chat_ink2% : remark highlight messages I send
6030           print #chat_chan%,my_name$&": ";
6040           remark print the message, word-wrapped over the next lines
6050           remark chat window is 70 characters wide
6060           remark first line shorter to allow for nickname before message
6070 remark          ink #chat_chan%,chat_ink3%
6080           Wrap #chat_chan%,69-len(my_name$)-2,69,chat_ink3%,aa$
6090           ink #chat_chan%,chat_ink1%
6100           Log my_name$&" : "&aa$
6110         end if
6120         :
6130         remark ENTER pressed, end of current line input, reset for next input
6140         remark (the PRIVMSG or /command has been handled)
6150         aa$ = ""         : remark new blank user input line
6160         a$  = ""         : remark character handled
6170         cls #input_chan% : remark clear the input window
6180         curpos = 0       : remark reset cursor position to start of line
6190         curx%  = 0       : remark first character shown-1 in line (from 0)
6200         sx%    = 0       : remark start of visible section of input
6210         ex%    = 0       : remark end of visible section of input
6220       =32 to 191 : remark text character to add to aa$
6230         if curpos = 0 then
6240           aa$ = a$ & aa$ : remark at start of line
6250         else
6260           if curpos = len(aa$) then
6270             aa$ = aa$ & a$ : remark add to end of line
6280           else
6290             remark in the middle of the line
6300             aa$ = aa$(1 to curpos)&a$&aa$(curpos+1 to len(aa$))
6310           end if
6320         end if
6330         if len(aa$) > maxlen then aa$ = aa$(1 to maxlen)
6340         curpos = curpos + 1
6350         if curpos > len(aa$) then curpos = len(aa$)
6360         Show_Input_Line
6370       =192 : remark left
6380         curpos = curpos - (curpos > 0)
6390         if curpos < curx% then
6400           curx% = curx% - 1 : Show_Input_Line
6410         else
6420           at #input_chan%,0,curpos-curx%
6430         end if
6440       =200 : remark right
6450         curpos = curpos+(curpos < len(aa$))
6460         if curpos > (curx%+83) then
6470           curx% = curx%+1 : Show_Input_Line
6480         else
6490           at #input_chan%,0,curpos-curx%
6500         end if
6510       =196 : remark SHIFT left - cursor left by word
6520         remark move one character left then search for a space before
6530         remark any other character
6540         if curpos > 0 then
6550           for i = curpos-1 to 0 step -1
6560             if i = 0 then curpos = 0 : exit i
6570             if aa$(i) = " " and aa$(i+1) <> " " then curpos = i : exit i
6580           end for i
6590         end if
6600         if curpos < curx% then Show_Input_Line : else at #input_chan%,0,curpos-curx% : end if
6610       =204 : remark SHIFT right - cursor right by word
6620         if curpos < len(aa$) then
6630           for i = curpos+1 to len(aa$)
6640             if i = len(aa$) then curpos = i : exit i
6650             if aa$(i) = " " and aa$(i+1) <> " " then curpos = i : exit i
6660           end for i
6670           if curpos <= (curx%+82) then at #input_chan%,0,curpos-curx% :else Show_Input_Line : end if
6680         end if
6690       =193 : remark ALT left to start of line
6700         curpos = 0
6710         if curpos < curx% then
6720           curx% = 0 : Show_Input_Line
6730         else
6740           at #input_chan%,0,curpos-curx%
6750         end if
6760       =201 : remark ALT right to end of line
6770         curpos = len(aa$)
6780         if curpos > (curx%+83) then
6790           curx% = curpos-83
6800           if curx% < 0 then curx% = 0
6810           Show_Input_Line
6820         else
6830           at #input_chan%,0,curpos-curx%
6840         end if
6850       =208,216 : remark replace current input line with last_entry$
6860         aa$ = last_entry$ : curpos = len(aa$) : curx% = 0
6870         Show_Input_Line
6880       =195,218,27 : remark CTL ALT left, CTL down, ESC - delete entire line
6890         aa$ = '' : a$ = '' : curpos = 0 : curx% = 0 : cls #input_chan%
6900       =203 : remark CTL ALT right - delete right of line past cursor
6910         if curpos < len(aa$) then
6920           if curpos > 0 then aa$ = aa$(1 to curpos) : else aa$ = "" : end if
6930           curpos = len(aa$) : Show_Input_Line
6940         end if
6950       =194 : rem CTL left delete character before cursor
6960         if curpos > 0 and len(aa$) > 0 then
6970           if curpos = 1 then
6980             curpos = 0
6990             if len(aa$) = 1 then aa$ = "" : else aa$ = aa$(2 to len(aa$))
7000             Show_Input_Line : next mainloop
7010           end if
7020           if curpos = len(aa$) then
7030             aa$ = aa$(1 to len(aa$)-1) : curpos = curpos-1
7040             Show_Input_Line : next mainloop
7050           end if
7060           aa$ = aa$(1 to curpos-1) & aa$(curpos+1 to len(aa$))
7070           curpos = curpos - 1
7080           Show_Input_Line
7090         end if
7100       =202 : rem CTL right, delete a character under cursor
7110         if len(aa$) > 0 and curpos < len(aa$) then
7120           if len(aa$) = 1 then
7130             if curpos = 0 then aa$ = ''
7140           else
7150             if curpos = 0 then
7160               aa$ = aa$(2 to len(aa$))
7170             else
7180               if curpos = len(aa$)-1 then
7190                 aa$ = aa$(1 to len(aa$)-1)
7200               else
7210                 aa$ = aa$(1 to curpos) & aa$(curpos+2 to len(aa$))
7220               end if
7230             end if
7240           end if
7250           Show_Input_Line
7260         end if
7270       =248 : remark toggle beep-on-message off/on
7280         beep_on_message% = not beep_on_message%
7290         print #chat_chan%,"* Beep On Message now ";
7300         if beep_on_message% = 0 then
7310           print #chat_chan%,"off *"
7320         else
7330           print #chat_chan%,"on *"
7340         end if
7350       =9 : remark TAB - auto-complete user name from list
7360         if aa$ <> "" and aa$ <> fill$(" ",len(aa$)) and curpos > 0 then
7370           remark TAB - auto-complete user name from list
7380           remark look for the word just before the cursor, which is used as
7390           remark the stub to search for a match in the names list. The name
7400           remark matched is joined to the left part of the input before the
7410           remark stub and followed by a colon if at the start of the input,
7420           remark then by a space, then by the right hand side of the entry.
7430           remark (this is consistent with the Mibbit client method
7440           remark ----------------------------------------------------------
7450           lft$   = "" : remark the part to the left of the stub
7460           rgt$   = "" : remark the part to the right of the stub
7470           stub$  = "" : remark the part to look up in the nicknames list
7480           :
7490           remark find the part before the word stub
7500           for c = curpos to 1 step -1
7510             if c = 1 and aa$(c) <> " " then
7520               rem no space between cursor and start of input line
7530               stub$ = aa$(1 to curpos)
7540               if curpos < len(aa$) then rgt$ = aa$(curpos+1 to len(aa$))
7550               exit c
7560             end if
7570             if aa$(c) = " " then
7580                lft$ = aa$(1 to c)         : remark part before the stub
7590                stub$ = aa$(c+1 to curpos) : remark the search stub
7600                if curpos < len(aa$) then rgt$ = aa$(curpos+1 to len(aa$))
7610                exit c
7620             end if
7630           end for c
7640           :
7650           remark try to extract a name stub
7660           remark find the right part, from cursor to end of input
7670           :
7680           if stub$ <> "" then
7690             for c = 0 to users-1
7700               if (stub$ instr user$(c)) = 1 then
7710                 aa$ = lft$&user$(c)
7720                 if lft$ = "" then aa$ = aa$&":" : remark at start of line
7730                 if code(rgt$) <> 32 then aa$ = aa$&' '
7740                 curpos = len(aa$) : remark after anything added
7750                 aa$ = aa$ & rgt$
7760                 Show_Input_Line
7770               end if
7780             end for c
7790           end if
7800         end if
7810       =232 : Help_Text : remark F1 for list of /commands
7820     end select
7830   end if
7840   :
7850   remark +------------------------------------------------------------------+
7860   remark | INCOMING - Get input from Chat Server                            |
7870   remark +------------------------------------------------------------------+
7880   :
7890   b$ = inkey$(#tcp_chan%,0) : remark one character from Chat
7900   if b$ = chr$(10) then
7910     remark end of line (LF) - bb$ is the string sent by the chat server
7920     Log ">" & bb$ & " ["&date$&"]"
7930     bb$ = Uncr$(bb$) : remark remove any carriage returns
7940     if bb$ = "" then next mainloop : remark blank line, ignore
7950     :
7960     remark ------------------------------------------------------------
7970     remark Parse the message received from server to break up into the
7980     remark main constituent parts. Returns the following variables with
7990     remark elements of the message:
8000     remark
8010     remark   :nick!hostname COMMAND parameter$
8020     remark
8030     remark     sender$    = nickname of sender if present
8040     remark     hostname$  = host name
8050     remark     command$   = command name or numeric code in a reply
8060     remark     parameter$ = parameters after nickname, may include
8070     remark                  nickname or channel name for example
8080     remark ------------------------------------------------------------
8090     Parse_Response bb$
8100     :
8110     remark message format is likely to be
8120     remark     :nickname!realname PRIVMSG #qlforum :message
8130     remark or  PING :server
8140     :
8150     if command$ == "PRIVMSG" or command$ == "NOTICE" then
8160       remark +---------------------------+
8170       remark | Handle PRIVMSG and NOTICE |
8180       remark +---------------------------+
8190       remark message format ":username!server PRIVMSG #channel :message_text"
8200       remark or (PM)  :username!server PRIVMSG nickname!server :message_text
8210       remark N.B. #channel can be:
8220       remark #channel = global channel (e.g. #QLForum for QL Forum chat)
8230       remark &channel = channel local to a server
8240       remark +channel = modeless channel without operator
8250       remark !channel = timestamped channel on non-timestamped networks
8260       :
8270       remark need to extract details from parameter$ including message
8280       remark parameter$ may be:
8290       remark   #channel :message_txt
8300       remark   nickname!hostname :message_text
8310       remark   nickname :message_text
8320       remark   userAThostname :message_text
8330       :
8340       remark ----------------------------------------------------------
8350       remark extract message$ as part from parameter$ to check for CTCP
8360       remark (CTCP is Client-To-Client Protocol)
8370       remark ----------------------------------------------------------
8380       remark if this is a CTCP command, message$ will then contain:
8390       remark <$01>COMMAND parameters<$01>
8400       remark the final hex value $01 may or may not be present
8410       :
8420       remark "Beep-On-Message-Received" (requested by Ralf Rekoendt)
8430       if beep_on_message% = 1 then beep beep_durtn%,beep_pitch%
8440       message_start = ' :' instr parameter$
8450       message$ = ""
8460       if message_start > 0 and message_start < (len(parameter$)-2) then
8470         remark message$ will contain the text of the message, without the
8480         remark leading ':' message start indicator, but if a CTCP command
8490         remark will include the CHR$(1)
8500         message$ = parameter$(message_start+2 to len(parameter$))
8510       end if
8520       :
8530       remark who was to receive this message?
8540       remark it may be a single user or an entire channel
8550       recipient$ = "" : remark who was to receive this message? May be channel.
8560       if message_start > 1 then
8570         recipient$ = parameter$(1 to message_start-1)
8580         pling = "!" instr recipient$ : remark isolate nickname?
8590         if pling > 0 then recipient$ = recipient$(1 to pling-1)
8600       end if
8610       :
8620       if code(message$) = 1 then
8630         remark a CTCP message such as ACTION
8640         remark message should have a chr$(1) at the end, but some servers
8650         remark may truncate it. message$ is passed as the PRIVMSG's message
8660         remark part only, not including leading ':', but including CHR$(1)
8670         Process_CTCP_Command
8680       else
8690         remark normal PRIVMSG
8700 remark Discord QL-Bot fix to suppress the three UTF anti-looping
8710 remark characters ^ inserted in sender <n^ame> in message$ by QL-Bot
8720 remark this is specifically for Discord channel on QLforum
8730 if QL_Bot_adjust = 1 then
8740   if sender$ = 'QL-Bot' THEN
8750     REMark cut out the 3 spurious characters for display purposes
8760     message$ = message$(1 to 2)&message$(6 to len(message$))
8770   end if
8780 end if
8790         ink #chat_chan%,chat_ink2%
8800         if recipient$ == my_name$ then
8810           remark private message to me - remember who sent it so that a
8820           remark "/msg ," knows who to reply to
8830           last_pm_name$ = sender$
8840           sender$ = sender$&"*(PM)*"
8850         end if
8860         sender$ = sender$ & ": "
8870         print #chat_chan%,sender$;
8880         ink #chat_chan%,chat_ink1%
8890         remark print the message, word-wrapped over the next lines
8900         remark chat window is 70 characters wide.
8910         remark first line has to allow for the sender's nickname
8920         remark the Y+10 in next line is message start after "#QLForum :"
8930         Wrap #chat_chan%,69-len(sender$),69,chat_ink1%,message$ : remark msg after mask
8940         Log sender$&message$ : remark ": " after name added just above
8950       end if
8960       command$ = "" : remark command acted upon
8970     end if
8980 :
8990     if command$ == "ERROR" then
9000       remark server reporting an error ERROR <message>
9010       print #chat_chan%,bb$ : Log bb$
9020     end if
9030 :
9040     if command$ == "JOIN" then
9050       remark someone new joined -  :username!realname JOIN :#QLForum
9060       a = "!" instr bb$ : remark end of username joining
9070       user1$ = bb$(2 to a-1) : remark nickname is between : and !
9080       a = code(user1$) : remark look for nickname prefix
9090       if a=126 or a=38 or a=64 or a=37 or a=43 then
9100         ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
9110       else
9120         ustat$(users) = "" : remark no name prefix
9130         user$(users) = user1$
9140       end if
9150       print #list_chan%,ustat$(users);user$(users)
9160       print #chat_chan%,chr$(189);" ";user1$;" has joined."
9170       Log chr$(189)&" "&user1$&" has joined."
9180       users = users + 1 : remark one more name added to end of list
9190       command$ = "" : remark command acted upon
9200     end if
9210     :
9220     if command$ == "MODE" then
9230       remark MODE nickname +/-modeflagletters (aiwroOs)
9240       print #chat_chan%,command$&" "&parameter$
9250       Log command$&" "&parameter$
9260       remark the MODE command is difficult to parse, and may include
9270       remark such things as operator status changes, so take the easy
9280       remark option and ask for a new names list.
9290       users = 0 : remark number of names in the list
9300       dim ustat$(max_users%-1,2),user$(max_users%-1,30) : remark users
9310       remark send NAMES command to server to request names list
9320       print #tcp_chan%,"NAMES "&forum$ : Log "/Names "&forum$
9330       remark arrays will be filled on receipt of 353/366 responses
9340       remark and names list redrawn after 353 and 366 processed
9350     end if
9360     :
9370     if command$ == "NICK" then
9380       remark someone (sender$) changed their nickname
9390       remark extract new nickname from parameter$
9400       new_name$ = parameter$
9410       if code(new_name$) = code(':') then
9420         if len(parameter$) > 1 then
9430           new_name$ = new_name$(2 to len(new_name$))
9440         else
9450           new_name$ = ""
9460         end if
9470       end if
9480       for a = 0 to users-1
9490         if sender$ == user$(a) then
9500           user$(a) = new_name$
9510           my_name$ = new_name$
9520           Wrap #chat_chan%,69,69,chat_ink3%,sender$&" is now known as "&new_name$
9530           Log sender$&" is now known as "&new_name$
9540           exit a
9550         end if
9560       end for a
9570       Show_Users_List
9580       command$ = "" : remark command acted upon
9590     end if
9600     :
9610     if command$ == "PART" then
9620       remark user departed from the online chat
9630       remark locate this user in the list
9640       for x = 0 to users-1
9650         if sender$ == user$(x) then
9660           remark remove this user's name from the list and move others up
9670           for b = x to users-2
9680             user$(b) = user$(b+1) : ustat$(b) = ustat$(b+1)
9690           end for b
9700           user$(users-1)  = "" : remark blank out last user name in list
9710           ustat$(users-1) = "" : remark and nickname prefix
9720           users = users - 1    : remark one less user now
9730           exit x               : remark job done
9740         end if
9750       end for x
9760       Show_Users_List : remark display revised list of users
9770       print #chat_chan%,chr$(188) & " " & sender$ & " has left."
9780       Log chr$(188) & " " & sender$ & " has left."
9790       command$ = "" : remark command acted upon
9800     end if
9810 :
9820     if command$ == "PING" then
9830       remark server testing for presence of the client, needs a quick
9840       remark response or the connection will be closed by server,
9850       remark #QLForum timeout is usually about 180 seconds.
9860       remark format expected:   PING :irc.us.mibbit.net
9870       remark respond with   :   PONG :irc.us.mibbit.net
9880       print #tcp_chan%,"PONG "&parameter$&crlf$;
9890       Log "PONG "&parameter$&" ["&DATE$&"]"
9900       command$ = "" : remark command acted upon
9910     end if
9920 :
9930     if command$ == "QUIT" then
9940       remark user client quit from IRC
9950       remark   :nickname!host QUIT :Quit :nickname_message
9960       remark locate this user in the list
9970       for x = 0 to users-1
9980         if sender$ == user$(x)  then
9990           remark remove this user's name from the list and move others up
10000           for b = x to users-2
10010             user$(b) = user$(b+1) : ustat$(b) = ustat$(b+1)
10020           end for b
10030           user$(users-1) = "" : remark blank out last user name in list
10040           ustat$(users-1)= "" : rem nickname prefix
10050           users = users - 1   : remark one less user now
10060           exit x              : remark job done
10070         end if
10080       end for x
10090       Show_Users_List : remark display revised users list
10100       print #chat_chan%,chr$(188) & " " & sender$ & " has quit."
10110       Log chr$(188) & " " & sender$ & " has quit."
10120       command$ = "" : remark command acted upon
10130     end if
10140     :
10150     if command$ == "TOPIC" then
10160       remark someone changed the topic
10170       remark   :nick!host TOPIC #channel :new_topic_text
10180       w = ":" instr parameter$
10190       topic$ = ""
10200       if w < len(parameter$) then topic$ = parameter$(w+1 to len(parameter$))
10210 remark      ink #chat_chan%,chat_ink2%
10220       Wrap #chat_chan%,69,69,chat_ink2%,sender$&" changed the topic to:"&topic$
10230       ink #chat_chan%,chat_ink1%
10240       command$ = "" : remark command acted upon
10250     end if
10260     :
10270     remark this routine handles 3-digit replies and errors in "command$"
10280     remark the function tests for 3 digit command$ length and if numeric
10290     Numeric_Reply
10300     :
10310     bb$ = "" : remark reset string after received message processed
10320   else
10330     remark anything but linefeed/enter character
10340     bb$ = bb$ & b$ : remark add character received from server
10350   end if
10360 :
10370 end repeat mainloop
10380 :
10390 close #tcp_chan%              : remark TCP channel number
10400 close #chat_chan%             : remark Chat window
10410 close #input_chan%            : remark Inputs window
10420 close #list_chan%             : remark Users list window
10430 if log% then close #log_chan% : remark the logging file
10440 stop
10450 :
10460 def proc Log (str$)
10470   remark text sent and received logged to a file locally
10480   if log% then print #log_chan%,str$
10490 end def Log
10500 :
10510 def fn Uncr$(str$)
10520   local st$
10530   remark strip any carriage returns from start or end of string
10540   st$ = str$
10550   if len(st$) > 0 then
10560     if st$(len(st$)) = chr$(13) then
10570       remark last character in line is CR
10580       if len(st$) > 1 then st$ = st$(1 to len(st$)-1) : else st$ = "" : end if
10590     else
10600       if code(st$) = 13 then
10610         remark line starts with CR
10620         if len(st$) = 1 then st$ = "" : else st$ = st$(2 to len(st$)) : end if
10630       end if
10640     end if
10650   end if
10660   ret st$ : remark return string minus any CR character
10670 end def Uncr$
10680 :
10690 def fn Unspace$(str$)
10700   remark remove spaces from both ends of a string
10710   local x,a$
10720   a$ = str$
10730   remark remove any leading spaces
10740   for x = 1 to len(a$) : if a$(x) <> " " then a$ = a$(x to len(a$)) : exit x
10750   remark remove any trailing spaces
10760   for x = len(a$) to 1 step -1 : if a$(x) <> " " then a$ = a$(1 to x) : exit x
10770   return a$
10780 end def Unspace$
10790 :
10800 def proc Wrap (chan,cpl1,cpl2,text_ink%,str$)
10810   remark word wrap a string, allows for different line lengths
10820   remark for the first line and subsequent lines.
10830   remark by default, chat window lines are (432-8)/6=70 characters
10840   local para$,cpl,wrapping,a,b
10850   para$ = str$
10860   cpl = cpl1 : remark first line shorter after nickname:
10870   repeat wrapping
10880     if para$ = "" then exit wrapping
10890     if len(para$) <= cpl then
10900       Print_Line #chan,1,text_ink%,para$ : remark 1=highlight name in line
10910       exit wrapping
10920     end if
10930     remark find a space, a point to break the line
10940     for a = cpl to 1 step -1
10950       if para$(a+1) = " " and para$(a) <> " " then
10960         Print_Line #chan,1,text_ink%,para$(1 to a)
10970         cpl = cpl2
10980         remark find next non-space character (i.e start of next line)
10990         for b = a+1 to len(para$)
11000           if para$(b) <> " " then
11010             para$ = para$(b to len(para$))
11020             exit a
11030           end if
11040         next b
11050           remark no non-space found
11060           para$ = "" : remark drop all spaces off end
11070         end for b
11080       end if
11090     next a
11100       remark no space found, just print a lineful and chop
11110       Print_Line #chan,1,text_ink%,para$(1 to cpl)
11120       para$ = para$(cpl+1 to len(para$))
11130     end for a
11140   end repeat wrapping
11150 end def Wrap
11160 :
11170 def proc Print_Line (ch,highlight,t_ink%,lne$)
11180   local x
11190   x = my_name$ instr lne$ : ink #ch,t_ink%
11200   if x = 0 then
11210     print #ch,lne$ : remark all of line (my name not found in the line)
11220   else
11230     if highlight_sound% then beep 1000,20   : remark own name detected
11240     if x > 1 then print #ch,lne$(1 to x-1); : remark part before name
11250     ink #ch,chat_ink2% : remark highlight the name in different colour
11260     print #ch,lne$(x to x+len(my_name$)-1); : remark the name part
11270     ink #ch,t_ink% : remark back to normal text colour
11280     if x+len(my_name$)-1 < len(lne$) then
11290       remark more text after the name
11300       print #ch,lne$(x+len(my_name$) to len(lne$));
11310     end if
11320     print #ch, : remark newline
11330   end if
11340 end def Print_Line
11350 :
11360 def proc Show_Input_Line
11370   local endx%
11380   remark allows display of visible length of a longer input string
11390   curdis #input_chan%
11400   endx% = curx%+82
11410   if curpos > endx% then
11420     endx% = curpos : if endx% > (len(aa$)-1) then endx% = len(aa$)-1
11430     curx% = curpos-82 : if curx% < 0 then curx% = 0
11440   else
11450     if curpos < curx% then
11460       curx% = curpos
11470       endx% = curx%+82
11480       if endx% >= len(aa$) then endx% = len(aa$)-1
11490     end if
11500   end if
11510   if endx% >= len(aa$) then endx% = len(aa$)-1
11520   if endx% > (curx%+82) then endx% = curx%+82
11530   at #input_chan%,0,0
11540   if aa$ <> '' then print #input_chan%,aa$(curx%+1 to endx%+1);
11550   cls #input_chan%,4
11560   at #input_chan%,0,curpos-curx%
11570   cursen #input_chan%
11580 end def Show_Input_Line
11590 :
11600 def proc Show_Users_List
11610   loc x
11620   remark Print list of users in the right hand window
11630   remark windows is 72 pixels wide (12 characters) allowing display
11640   remark of first 12 characters of nicknames, which should be limited
11650   remark to 9 characters (10 including status prefix), but can be
11660   remark modified in server settings, QL Forum seems to allow up to
11670   remark 30 characters in a nickname
11680   cls #list_chan%
11690   for x = 0 to users-1
11700     if (len(ustat$(x))+len(user$(x))) > 14 then
11710       print #list_chan%,ustat$(x)&user$(x,1 to 13+len(ustat$(x)))
11720     else
11730       print #list_chan%,ustat$(x)&user$(x)
11740     end if
11750     Log ustat$(x)&user$(x)
11760   end for x
11770 end def Show_Users_List
11780 :
11790 def proc Xtv
11800   outln #0,scr_xlim,scr_ylim,0,0
11810   window scr_xlim,scr_ylim-52,0,0
11820   window #2,scr_xlim,scr_ylim-52,0,0
11830   window #0,scr_xlim,52,0,scr_ylim-52
11840   border #1,1,255 : border #2,1,255 : border #0,1,255
11850   cls : cls #2 : cls #0
11860 end def Xtv
11870 :
11880 def proc Xtv2
11890   outln #0,scr_xlim/2,scr_ylim,0,0
11900   window #1,scr_xlim/2,scr_ylim-52,0,0
11910   window #2,scr_xlim/2,scr_ylim-52,0,0
11920   window #0,scr_xlim/2,52,0,scr_ylim-52
11930   border #1,1,255 : border #2,1,255 : border #0,1,255
11940   cls : cls #2 : cls #0
11950 end def Xtv2
11960 :
11970 def proc Parse_Response (msg$)
11980   local pling
11990   remark extract nickname, hostname, command/numeric and parameters from
12000   remark the response message received, e.g.
12010   remark   :[nickname!]host COMMAND [nickname] parameters :message_text
12020   remark the parameters vary depending on which command/numeric received
12030   remark returns:  sender$    = sender's nickname if present
12040   remark           host$      = host name if present
12050   remark           command$   = command name or numeric code
12060   remark           parameter$ = parameters after command, may include nickname
12070   :
12080   if msg$ = "" then return : remark oops, blank message
12090   :
12100   prefix$    = ""   : remark the whole part before the command host and nickname
12110   host$      = ""   : remark host name, the part between nickname and command
12120   sender$    = ""   : remark sender's nickname if present (before ! and host)
12130   command$   = msg$ : remark assume no nick/host names before it
12140   parameter$ = ""   : remark parameters after the command, may include nickname
12150   :
12160   if msg$(1) = ":" then
12170     spc = " " instr msg$ : remark ":nickname!host " part before code or command
12180     remark prefix$: some commands need full nickname + hostname
12190     remark although the leading ":" is not necessary, so start at 2
12200     if spc > 2 then prefix$ = msg$(2 to spc-1) : host$ = prefix$
12210     if host$ <> "" then
12220       remark check if there's a nickname before the host name
12230       pling = "!" instr host$
12240       if pling > 0 then
12250         remark yes, try to extract nickname
12260         sender$ = host$(1 to pling-1)          : remark nickname before "!"
12270         host$   = host$(pling+1 to len(host$)) : remark remove nickname
12280       else
12290         remark no host, just a nickname
12300         sender$ = host$ : host$ = ""
12310       end if
12320     end if
12330     if spc > 0 then command$ = msg$(spc+1 to len(msg$))
12340   end if
12350   :
12360   remark separate command number/name and parameters
12370   spc = " " instr command$
12380   if spc > 0 then
12390     remark parameter$ may start with nickname for some commands
12400     parameter$ = command$(spc+1 to len(command$))
12410     command$ = command$(1 to spc-1) : remark the command/numeric part
12420   end if
12430   :
12440   remark parameter$ may contain various data such as a nickname, a message
12450   remark text following a ":" etc so best handled by the routines calling
12460   remark this procedure individually
12470   :
12480 end def Parse_Response
12490 :
12500 def fn Numeric (str$)
12510   loc a,ok%
12520   ok% = 1
12530   if str$ = "" then
12540     ok% = 0
12550   else
12560     for a = 1 to len(str$)
12570       if str$(a) < "0" or str$(a) > "9" then ok% = 0 : exit a
12580     end for a
12590   end if
12600   ret ok%
12610 end def Numeric
12620 :
12630 def proc Numeric_Reply
12640   local cmd
12650   remark 001-099 client-server connections only
12660   remark 200-399 command response replies
12670   remark 400-599 are error condition replies
12680   :
12690   remark this routine only handles 3-digit numeric responses
12700   if Numeric(command$) = 0 or len(command$) <> 3 then return
12710   :
12720   remark The 3 digit numeric code is in "command$"
12730   cmd = command$
12740   remark Any text message etc will be in parameter$ but need separate
12750   remark handling in many cases. Not all applicable to QLirc.
12760   remark ReplyMsg is a general routine for messages with no individual
12770   remark handler, while ErrMsg is the same for error messages. Individual
12780   remark message codes can have their own handler routines where need be.
12790   :
12800   sel on cmd
12810     =1 : remark RPL_WELCOME
12820     =2 : remark RPL_YOURHOST
12830     =3 : remark RPL_CREATED
12840     =4 : remark RPL_MYINFO
12850     =5 : remark RPL_BOUNCE
12860     =200 : ReplyMsg : remark RPL_TRACELINK
12870     =201 : ReplyMsg : remark RPL_TRACECONNECTING
12880     =202 : ReplyMsg : remark RPL_TRACEHANDSHAKE
12890     =203 : ReplyMsg : remark RPL_TRACEUNKNOWN
12900     =204 : ReplyMsg : remark RPL_TRACEOPERATOR
12910     =205 : ReplyMsg : remark RPL_TRACEUSER
12920     =206 : ReplyMsg : remark RPL_TRACESERVER
12930     =207 : ReplyMsg : remark RPL_TRACESERVICE
12940     =208 : ReplyMsg : remark RPL_TRACENEWTYPE
12950     =209 : ReplyMsg : remark RPL_TRACECLASS
12960     =210 : ReplyMsg : remark RPL_TRACERECONNECT
12970     =211 : ReplyMsg : remark RPL_STATSLINKINFO
12980     =212 : ReplyMsg : remark RPL_STATSCOMMAND
12990     =213 : ReplyMsg : remark RPL_STATSCLINE
13000     =214 : ReplyMsg : remark RPL_STATSNLINE
13010     =215 : ReplyMsg : remark RPL_STATSILINE
13020     =216 : ReplyMsg : remark RPL_STATSKLINE
13030     =217 : ReplyMsg : remark RPL_STATSQLINE
13040     =218 : ReplyMsg : remark RPL_STATSYLINE
13050     =219 : ReplyMsg : remark RPL_ENDOFSTATS
13060     =221 : ReplyMsg : remark RPL_UMODEIS
13070     =231 : ReplyMsg : remark RPL_SERVICEINFO
13080     =232 : ReplyMsg : remark RPL_ENDOFSERVICES
13090     =233 : ReplyMsg : remark RPL_SERVICE
13100     =234 : ReplyMsg : remark RPL_SERVLIST
13110     =235 : ReplyMsg : remark RPL_SERVLISTEND
13120     =240 : ReplyMsg : remark RPL_STATSVLINE
13130     =241 : ReplyMsg : remark RPL_STATSLLINE
13140     =242 : ReplyMsg : remark RPL_STATSUPTIME
13150     =243 : ReplyMsg : remark RPL_STATSOLINE
13160     =244 : ReplyMsg : remark RPL_STATSHLINE
13170     =245 : ReplyMsg : remark RPL_STATSSLINE
13180     =246 : ReplyMsg : remark RPL_STASPING
13190     =247 : ReplyMsg : remark RPL_STATSBLINE
13200     =249 : ReplyMsg : remark RPL_STATSDEBUG
13210     =250 : ReplyMsg : remark RPL_STATSDLINE
13220     =251 : ReplyMsg : remark RPL_LUSERCLIENT
13230     =252 : ReplyMsg : remark RPL_LUSEROP
13240     =253 : ReplyMsg : remark RPL_LUSERUNKNOWN
13250     =254 : ReplyMsg : remark RPL_LUSERCHANNELS
13260     =255 : ReplyMsg : remark RPL_LUSERME
13270     =256 : ReplyMsg : remark RPL_ADMINME
13280     =257 : ReplyMsg : remark RPL_ADMINLOC1
13290     =258 : ReplyMsg : remark RPL_ADMINLOC2
13300     =259 : ReplyMsg : remark RPL_ADMINEMAIL
13310     =261 : ReplyMsg : remark RPL_TRACELOG
13320     =262 : ReplyMsg : remark RPL_TRACEEND
13330     =263 : ReplyMsg : remark RPL_TRYAGAIN
13340     =300 : ReplyMsg : remark RPL_NONE
13350     =301 : ReplyMsg : remark RPL_AWAY
13360     =302 : ReplyMsg : remark RPL_USERHOST
13370     =303 : ReplyMsg : remark RPL_ISON
13380     =305 : ReplyMsg : remark RPL_UNAWAY
13390     =306 : ReplyMsg : remark RPL_NOWAWAY
13400     =311 : ReplyMsg : remark RPL_WHOISUSER
13410     =312 : ReplyMsg : remark RPL_WHOISSERVER
13420     =313 : ReplyMsg : remark RPL_WHOISOPERATOR
13430     =314 : ReplyMsg : remark RPL_WHOWASUSER
13440     =315 : ReplyMsg : remark RPL_ENDOFWHO
13450     =316 : ReplyMsg : remark RPL_WHOISCHANOP
13460     =317 : ReplyMsg : remark RPL_WHOISIDLE
13470     =318 : ReplyMsg : remark RPL_ENDOFWHOIS
13480     =319 : ReplyMsg : remark RPL_WHOISCHANNELS
13490     =321 : ReplyMsg : remark RPL_LISTSTART
13500     =322 : ReplyMsg : remark RPL_LIST
13510     =323 : ReplyMsg : remark RPL_LISTEND
13520     =324 : ReplyMsg : remark RPL_CHANNELMODEIS
13530     =325 : ReplyMsg : remark RPL_UNIQOPIS
13540     =329 : ReplyMsg : remark RPL_CREATIONTIME
13550     =331 : ReplyMsg : remark RPL_NOTOPIC
13560     =332 : RPL_Topic : remark RPL_TOPIC - channel topic of the day message
13570     =333 : RPL_TopicWhoTime : remark RPL_TOPICWHOTIME set by whom+when?
13580     =341 : ReplyMsg : remark RPL_INVITING
13590     =342 : ReplyMsg : remark RPL_SUMMONING
13600     =346 : ReplyMsg : remark RPL_INVITELIST
13610     =347 : ReplyMsg : remark RPL_ENDOFINVITELIST
13620     =348 : ReplyMsg : remark RPL_EXCEPTLIST
13630     =349 : ReplyMsg : remark RPL_ENDOFEXEPTLIST
13640     =351 : ReplyMsg : remark RPL_VERSION
13650     =352 : ReplyMsg : remark RPL_WHOREPLY
13660     =353 : remark RPL_NAMREPLY - list of nicknames from server
13670            remark add to anything already in names list arrays
13680            remark names list will be redrawn on receipt of 366
13690            RPL_NamReply
13700     =361 : ReplyMsg : remark RPL_KILLDONE
13710     =362 : ReplyMsg : remark RPL_CLOSING
13720     =363 : ReplyMsg : remark RPL_CLOSEEND
13730     =364 : ReplyMsg : remark RPL_LINKS
13740     =365 : ReplyMsg : remark RPL_ENDOFLINKS
13750     =366 : remark RPL_ENDOFNAMES - end of list of nicknames
13760            remark so redraw user nicknames list.
13770            Show_Users_List
13780     =367 : ReplyMsg : remark RPL_BANLIST
13790     =368 : ReplyMsg : remark RPL_ENDOFBANLIST
13800     =369 : ReplyMsg : remark RPL_ENDOFWHOWAS
13810     =371 : ReplyMsg : remark RPL_INFO
13820     =372 : ReplyMsg : remark RPL_MOTD
13830     =373 : ReplyMsg : remark RPL_INFOSTART
13840     =374 : ReplyMsg : remark RPL_RPL_ENDOFINFO
13850     =375 : ReplyMsg : remark RPL_MOTDSTART
13860     =376 : ReplyMsg : remark RPL_ENDOFMOTD
13870     =381 : ReplyMsg : remark RPL_YOUREOPER
13880     =382 : ReplyMsg : remark RPL_REHASHING
13890     =383 : ReplyMsg : remark RPL_YOURESERVICE
13900     =384 : ReplyMsg : remark RPL_MYPORTIS
13910     =385 : ReplyMsg : remark RPL_NOTOPERANYMORE
13920     =391 : ReplyMsg : remark RPL_TIME
13930     =392 : ReplyMsg : remark RPL_USERSTART
13940     =393 : ReplyMsg : remark RPL_USERS
13950     =394 : ReplyMsg : remark RPL_ENDOFUSERS
13960     =395 : ReplyMsg : remark RPL_NOUSERS
13970     =401 : ErrMsg : remark ERR_NOSUCHNICK
13980     =402 : ErrMsg : remark ERR_NOSUCHSERVER
13990     =403 : ErrMsg : remark ERR_NOSUCHCHANNEL
14000     =404 : ErrMsg : remark ERR_CANNOTSENDTOCHAN
14010     =405 : ErrMsg : remark ERR_TOOMANYCHANNELS
14020     =406 : ErrMsg : remark ERR_WASNOSUCHNICK
14030     =407 : ErrMsg : remark ERR_TOOMANYTARGETS
14040     =408 : ErrMsg : remark ERR_NOSUCHSERVICE
14050     =409 : ErrMsg : remark ERR_NOORIGIN
14060     =411 : ErrMsg : remark ERR_NORECIPIENT
14070     =412 : ErrMsg : remark ERR_NOTEXTTOSEND
14080     =413 : ErrMsg : remark ERR_NOTOPLEVEL
14090     =414 : ErrMsg : remark ERR_WILDTOPLEVEL
14100     =415 : ErrMsg : remark ERR_BADMASK
14110     =416 : ErrMsg : remark ERR_TOOMANYMATCHES
14120     =421 : ErrMsg : remark ERR_UNKNOWNCOMMAND
14130     =422 : ErrMsg : remark ERR_NOMOTD
14140     =423 : ErrMsg : remark ERR_NOADMININFO
14150     =424 : ErrMsg : remark ERR_FILEERROR
14160     =431 : ErrMsg : remark ERR_NONICKNAMEGIVEN
14170     =432 : ErrMsg : remark ERR_ERRONEUSNICKNAME
14180     =433 : ErrMsg : remark ERR_NICKNAMEINUSE
14190     =436 : ErrMsg : remark ERR_NICKCOLLISION
14200     =437 : ErrMsg : remark ERR_UNAVAILRESOURCE
14210     =441 : ErrMsg : remark ERR_USERNOTINCHANNEL
14220     =442 : ErrMsg : remark ERR_NOTONCHANNEL
14230     =443 : ErrMsg : remark ERR_USERONCHANNEL
14240     =444 : ErrMsg : remark ERR_NOLOGIN
14250     =445 : ErrMsg : remark ERR_SUMMONDISABLED
14260     =446 : ErrMsg : remark ERR_USERSDISABLED
14270     =451 : ErrMsg : remark ERR_NOTREGISTERED
14280     =461 : ErrMsg : remark ERR_NEEDMOREPARAMS
14290     =462 : ErrMsg : remark ERR_ALREADYREGISTERED
14300     =463 : ErrMsg : remark ERR_NOPERMFORHOST
14310     =464 : ErrMsg : remark ERR_PASSWDMISMATCH
14320     =465 : ErrMsg : remark ERR_YOUREBANNEDCREEP
14330     =466 : ErrMsg : remark ERR_YOUWILLBEBANNED
14340     =467 : ErrMsg : remark ERR_KEYSET
14350     =471 : ErrMsg : remark ERR_CHANNELISFULL
14360     =472 : ErrMsg : remark ERR_UNKNOWNMODE
14370     =473 : ErrMsg : remark ERR_INVITEONLYCHAN
14380     =474 : ErrMsg : remark ERR_BANNEDFROMCHAN
14390     =475 : ErrMsg : remark ERR_BADCHANNELKEY
14400     =476 : ErrMsg : remark ERR_BADCHANMASK
14410     =477 : ErrMsg : remark ERR_NOCHANMODES
14420     =478 : ErrMsg : remark ERR_BANLISTFULL
14430     =479 : ErrMsg : remark ERR_BADCHANNAME
14440     =481 : ErrMsg : remark ERR_NOPRIVILEGES
14450     =482 : ErrMsg : remark ERR_CHANOPRIVSNEEDED
14460     =483 : ErrMsg : remark ERR_CNATKILLSERVER
14470     =484 : ErrMsg : remark ERR_RESTRICTED
14480     =485 : ErrMsg : remark ERR_UNIQOPPRIVSNEEDED
14490     =491 : ErrMsg : remark ERR_NOOPERHOST
14500     =492 : ErrMsg : remark ERR_NOSERVICEHOST
14510     =501 : ErrMsg : remark ERR_UMODEUNKNOWNFLAG
14520     =502 : ErrMsg : remark ERR_USERSDONTMATCH
14530   end select
14540 end def Numeric_Reply
14550 :
14560 def proc ErrMsg
14570   remark message codes 401-599 are error messages
14580   Wrap #chat_chan%,69,69,chat_ink2%,"ERROR "&command$&" "&parameter$
14590   Log ">ERROR "&command$&" "&parameter$
14600 end def ErrMsg
14610 :
14620 def proc ReplyMsg
14630   remark a general reply message handling routine for cases where the
14640   remark individual replies aren't handled individually case by case.
14650 remark  ink #chat_chan%,chat_ink2%
14660   Wrap #chat_chan%,69,69,chat_ink2%,"REPLY: "&command$&" "&parameter$
14670   ink #chat_chan%,chat_ink1%
14680   Log ">REPLY: "&command$&" "&parameter$&crlf$;
14690 end def ReplyMsg
14700 :
14710 def proc Process_CTCP_Command
14720   loc spc,cmnd$,msg$,c$
14730   remark message$   = CTCP command between the two CHR$(1)'s of the original
14740   remark              PRIVMSG, including the CHR$(1)
14750   msg$ = message$ : remark working copy
14760   remark remove the CTRL-A / CHR$(1) from both ends of the CTCP message
14770   if code(msg$) = 1 then msg$ = msg$(2 to len(msg$))
14780   if msg$(len(msg$)) = chr$(1) then msg$ = msg$(1 to len(msg$)-1)
14790   :
14800   remark separate the CTCP command name and parameter(s)
14810   spc = " " instr msg$    : remark space after CTCP command
14820   cmnd$ = msg$(1 to spc-1) : remark the CTCP command
14830   msg$ = msg$(spc+1 to len(msg$)) : remark parameters to CTCP command
14840   :
14850   remark identify and process CTCP command
14860   remark remember that commands supported should be listed by CLIENTINFO
14870   remark possible commands:
14880   remark ACTION,CLIENTINFO,DCC,FINGER,PING,SOURCE,TIME,VERSION,USERINFO
14890   remark any replies required should be sent with a NOTICE
14900   :
14910   if cmnd$ == "ACTION" then
14920     remark no NOTICE reply needed
14930     remark replace ACTION with sender's nickname and print
14940 remark    ink #chat_chan%,chat_ink2%
14950     Wrap #chat_chan%,69,69,chat_ink2%,sender$&" "&msg$
14960     ink #chat_chan%,chat_ink1%
14970     Log sender$&" "&message$
14980     return
14990   end if
15000   :
15010   if cmnd$ == "CLIENTINFO" then
15020     remark needs a NOTICE reply with space-separated list of CTCP commands
15030     remark supported by this client - add to c$ as required
15040     c$ = "NOTICE "&prefix$&" :"&chr$(1)&"CLIENTINFO "
15050     c$ = c$ & "ACTION "         : remark supports ACTION
15060     c$ = c$ & "CLIENTINFO "     : remark ...and CLIENTINFO
15070     c$ = c$ & "FINGER "         : remark ...and FINGER
15080     c$ = c$ & "PING "           : remark ...and PING
15090     c$ = c$ & "SOURCE "         : remark ...and SOURCE
15100     c$ = c$ & "TIME "           : remark ...and TIME
15110     c$ = c$ & "USERINFO "       : remark ...and USERINFO
15120     c$ = c$ & "VERSION "        : remark ...and VERSION.
15130     c$ = c$ & chr$(1) & crlf$ : remark end of CTCP command
15140     print #tcp_chan%,c$; : Log c$
15150     return
15160   end if
15170   :
15180   if cmnd$ == "DCC" then
15190     remark Direct Client Connections (file transfers etc)
15200     remark not yet supported.
15210   end if
15220   :
15230   if cmnd$ == "FINGER" then
15240     remark return miscellaneous info about the user, typically the same
15250     remark info that's held in their realname field, or the client name
15260     remark and version instead in response to FINGER metadata query.
15270     c$ = "NOTICE "&prefix$&" "&chr$(1)&"FINGER "&progname$&" "&version$
15280     c$ = c$ & chr$(1) & crlf$
15290     print #tcp_chan%,c$ : Log c$
15300     return
15310   end if
15320   :
15330   if cmnd$ == "PING" then
15340     remark confirm reachability and check latency
15350     remark reply must contain exactly same parameters as original message
15360     c$ = "NOTICE "&chr$(1)&"PING "&message$&chr$(1)&crlf$
15370     print #tcp_chan%,c$; : Log c$&" ["&DATE$&"]"
15380     return
15390   end if
15400   :
15410   if cmnd$ == "SOURCE" then
15420     remark return location of the source code of the client
15430     c$ = "NOTICE "&prefix$&" "&chr$(1)&"SOURCE Not currently available."
15440     c$ = c$ & chr$(1) & crlf$
15450     print #tcp_chan%,c$; : Log c$
15460   end if
15470   :
15480   if cmnd$ == "TIME" then
15490     remark return local time in human-readable form
15500     c$ = "NOTICE "&prefix$&" "&chr$(1)&"TIME "&DATE$&chr$(1)&crlf$
15510     print #tcp_chan%,c$ : Log c$
15520     return
15530   end if
15540   :
15550   if cmnd$ == "VERSION" then
15560     remark return client name and version number
15570     c$ = "NOTICE "&prefix$&" "&chr$(1)&"VERSION "&progname$&" "&version$
15580     c$ = c$ & chr$(1) & crlf$
15590     print #tcp_chan%,c$ : Log c$
15600     return
15610   end if
15620   :
15630   if cmnd$ == "USERINFO" then
15640     remark return miscellaneous info about the user (largely obsolete)
15650     c$ = "NOTICE "&prefix$&" "&chr$(1)&"USERINFO "&my_name$&chr$(1)&crlf$
15660     print #tcp_chan%,c$ : Log c$
15670     return
15680   end if
15690   :
15700 end def Process_CTCP_Command
15710 :
15720 def proc Title
15730   local sc$
15740   remark print title heading - program name or Query Mode (PM) warning notice
15750   cls #title_chan%
15760   if query_mode% = 0 then
15770     sc$ = progname$ & " v"&version$
15780     at #title_chan%,0,(85-len(sc$)) div 2
15790   else
15800     sc$ = "QUERY MODE - Private Messaging With "&last_pm_name$
15810   end if
15820   if len(sc$) > 83 then sc$ = sc$(1 to 83)
15830   print #title_chan%,sc$;
15840 end def Title
15850 :
15860 def proc Draw_Display
15870   remark +----------------------------------------------------------+
15880   remark | Draw the main windows e.g. after /move or /resize        |
15890   remark | chat_chan%,input_chan%,list_chan%=#4,#5,#6 in v1.00      |
15900   remark +----------------------------------------------------------+
15910   remark get screen sizes to make sure origin not out of range
15920   Screen_Size
15930   if ox%+512 > wide% then ox% = wide%-512
15940   if oy%+256 > high% then oy% = high%-256
15950   :
15960   window #chat_chan%,424,232,ox%,oy%+12
15970   window #input_chan%,512,12,ox%,oy%+244
15980   window #list_chan%,88,232,ox%+424,oy%+12
15990   window #title_chan%,512,12,ox%,oy%
16000   :
16010   border #title_chan%,1,title_border%
16020   paper #title_chan%,title_paper%
16030   ink #title_chan%,title_ink%
16040   Title
16050   :
16060   border #chat_chan%,1,chat_border%
16070   paper #chat_chan%,chat_paper%
16080   ink #chat_chan%,chat_ink1%
16090   cls #chat_chan%
16100   :
16110   border #input_chan%,1,input_border%
16120   paper #input_chan%,input_paper%
16130   ink #input_chan%,input_ink%
16140   cursor #input_chan%,0,0
16150   cls #input_chan%
16160   :
16170   border #list_chan%,1,list_border%
16180   paper #list_chan%,list_paper%
16190   ink #list_chan%,list_ink%
16200   cls #list_chan%
16210 end def Draw_Display
16220 :
16230 def proc Screen_Size
16240   local vv$
16250   wide% = 512 : remark default QL screen width
16260   high% = 256 : remark default QL screen height
16270   vv$ = ver$
16280   if vv$ = "HBA" then
16290     remark using SBASIC
16300     wide% = SCR_XLIM : remark width
16310     high% = SCR_YLIM : remark height
16320   end if
16330 end def Screen_Size
16340 :
16350 def proc Move_Display
16360   loc old_ox%,old_oy%,comma%,para$
16370   rem /move x,y command to move program windows to new location
16380   if len(aa$) > 6 then
16390     para$ = aa$(7 to len(aa$))
16400     comma% = "," instr para$
16410     if comma% > 0 then
16420       old_ox% = ox% : old_oy% = oy%
16430       if comma% > 1 then ox% = "0" & para$(1 to comma%-1)
16440       if comma% < len(para$) then oy% = "0"&para$(comma%+1 to len(para$))
16450       if ox% <> old_ox% or oy% <> old_oy% then
16460         Draw_Display : Show_Users_List
16470       end if
16480     end if
16490   end if
16500 end def Move_Display
16510 :
16520 def proc Join_Channel
16530   loc a,user1$
16540   remark send request to join the QLForum channel
16550   PRINT #tcp_chan%,"JOIN " & forum$ & crlf$;
16560   Log "JOIN " & forum$
16570   :
16580   remark expecting a multi-line reply
16590   remark 1. join confirmation response
16600   remark 2. RPL_TOPIC (332) channel topic message
16610   remark 3. RPL_TOPICWHOTIME (333) who set the topic and when (Unix time)
16620   remark 4. RPL_NAMREPLY (353) list of users online (the = means public channel)
16630   remark 5. RPL_ENDOFNAME (366) end of list of names
16640   :
16650   users = 0 : remark number of users online (elements 1 to users used in array)
16660   last_pm_name$ = "" : remark who sent the  Private Message to this channel
16670   :
16680   repeat loop
16690     input #tcp_chan%,in$ : Log ">"&in$
16700     in$ = Uncr$(in$)
16710     if in$ = "" then next loop
16720     :
16730     Parse_Response in$
16740     :
16750     if command$ = "332" then RPL_Topic : remark channel topic of the day
16760     :
16770     if command$ = "333" then RPL_TopicWhoTime : remark topic set by who+when
16780     :
16790     if command$ = "353" then
16800       remark RPL_NAMREPLY :sender 353 target_nickname = #QLForum :name1 name2 ...
16810       remark list of names online received from server
16820       w = ":" instr parameter$ : remark start
16830       who$ = ""
16840       if w < len(parameter$) then who$ = parameter$(w+1 to len(parameter$))
16850       repeat loop2
16860         if who$ = "" or users > 30 then exit loop2  : remark all names read
16870         if code(who$) = 32 then
16880           remark remove any leading or multiple spaces
16890           if len(who$) = 1 then who$ = "" : else who$ = who$(2 to len(who$))
16900           next loop2
16910         end if
16920         w = " " instr who$ : remark names are space separated
16930         if w = 0 then
16940           remark this list of names does not end with a space, so is last name
16950           user1$ = who$
16960           a = code(user1$) : remark check for nickname prefix
16970           if a=126 or a=38 or a=64 or a=37 or a=43 then
16980             ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
16990           else
17000             ustat$(users) = "" : user$(users) = user1$
17010           end if
17020           who$ = "" : remark final name
17030         else
17040           user1$ = who$(1 to w-1)
17050           a = code(user1$) : rem check for nickname prefix
17060           if a=126 or a=38 or a=64 or a=37 or a=43 then
17070             ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
17080           else
17090             ustat$(users) = "" : user$(users) = user1$
17100           end if
17110           if w < len(who$) then who$ = who$(w+1 to len(who$)) : else who$ = ""
17120         end if
17130         users = users + 1
17140       end rep loop2
17150     end if
17160     :
17170     if command$ = "366" then
17180       remark RPL_ENDOFNAMES :host 366 nickname #QLForum :End of /NAMES list.
17190       remark last line of reply to JOIN
17200       exit loop
17210     end if
17220   end repeat loop
17230   :
17240   Log "Number of users identified : "&users
17250   :
17260   remark Print list of users in the right hand window
17270   Show_Users_List
17280   :
17290   Wrap #chat_chan%,69,69,chat_ink2%,"Now joined to "&forum$&"."
17300   Log "Now joined to "&forum$&"."
17310 end define Join_Channel
17320 :
17330 def proc Get_Names_List
17340   local loop1,loop2,in$,w,who$,a,user1$
17350   print #tcp_chan%,"NAMES "&forum$
17360   Log "NAMES "&forum$
17370   remark empty the users list
17380   users = 0 : dim ustat$(max_users%-1,2),user$(max_users%-1,30)
17390   remark await the list from the server (or error message)
17400   repeat loop1
17410     input #tcp_chan%,in$ : in$ = Uncr$(in$) : Log ">"&in$
17420     if in$ = "" then next loop1
17430     :
17440     Parse_Response in$
17450     :
17460     remark check for 402 ERR_NOSUCHSERVER or 416 ERR_TOOMANYMATCHES
17470     if command$ = "402" or command$ = "416" then Numeric_Reply : exit loop1
17480     :
17490     if command$ = "353" then
17500       remark RPL_NAMREPLY :sender 353 target_nickname = #QLForum :name1 name2 ...
17510       remark list of names online received from server
17520       w = ":" instr parameter$ : remark start
17530       who$ = ""
17540       if w < len(parameter$) then who$ = parameter$(w+1 to len(parameter$))
17550       repeat loop2
17560         if who$ = "" or users > 30 then exit loop2  : remark all names read
17570         if code(who$) = 32 then
17580           remark remove any leading or multiple spaces
17590           if len(who$) = 1 then who$ = "" : else who$ = who$(2 to len(who$))
17600           next loop2
17610         end if
17620         w = " " instr who$ : remark names are space separated
17630         if w = 0 then
17640           remark this name does not end with a space, so is last name
17650           user1$ = who$
17660           a = code(user1$) : remark check for nickname prefix
17670           if a=126 or a=38 or a=64 or a=37 or a=43 then
17680             ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
17690           else
17700             ustat$(users) = "" : user$(users) = user1$
17710           end if
17720           who$ = "" : remark final name
17730         else
17740           remark space detected, so probably not the last name in the list
17750           user1$ = who$(1 to w-1)
17760           a = code(user1$) : rem check for username prefix
17770           if a=126 or a=38 or a=64 or a=37 or a=43 then
17780             ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
17790           else
17800             ustat$(users) = "" : user$(users) = user1
17810           end if
17820           if w < len(who$) then who$=who$(w+1 to len(who$)) : else who$ = ""
17830         end if
17840         users = users + 1
17850       end rep loop2
17860     end if
17870     :
17880     if command$ = "366" then
17890       remark RPL_ENDOFNAMES :host 366 nickname #QLForum :End of /NAMES list.
17900       remark last line of reply to JOIN
17910       exit loop1
17920     end if
17930   end repeat loop1
17940   :
17950   Log "Number of users identified : "&users
17960   :
17970   remark Print list of users in the right hand window
17980   Show_Users_List
17990   :
18000 end def Get_Names_List
18010 :
18020 def proc RPL_NamReply
18030   local spc,loop2,who$,user1$
18040   remark RPL_NAMREPLY :sender 353 target_nickname = #QLForum :name1 name2 ...
18050   remark list of names online received from server to add to nicknames list
18060   remark parameter$ is the part of the line after the 353 "command"
18070   spc = ":" instr parameter$ : remark start of names list
18080   who$ = "" : remark the nicknames list after the colon
18090   if spc < len(parameter$) then who$ = parameter$(spc+1 to len(parameter$))
18100   repeat loop2
18110     if who$ = "" or users > 30 then exit loop2  : remark all names read
18120     if code(who$) = 32 then
18130       remark remove any leading or multiple spaces
18140       if len(who$) = 1 then who$ = "" : else who$ = who$(2 to len(who$))
18150       next loop2
18160     end if
18170     spc = " " instr who$ : remark names are space separated, look for name end
18180     if spc = 0 then
18190       remark this list of names does not end with a space, so is last name
18200       remark of this 353 statement, although further 353 statements MAY
18210       remark follow later.
18220       user1$ = who$
18230       loop2 = code(user1$) : remark check for nickname prefix ( ~&at%+ )
18240       if loop2=126 or loop2=38 or loop2=64 or loop2=37 or loop2=43 then
18250         remark nickname has a status prefix, separate the name and prefix
18260         ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
18270       else
18280         remark no status prefix
18290         ustat$(users) = "" : user$(users) = user1$
18300       end if
18310       who$ = "" : remark that was the final name in this list
18320     else
18330       remark not the last name in the list
18340       user1$ = who$(1 to spc-1)
18350       loop2 = code(user1$) : rem check for nickname prefix ( ~&at%+ )
18360       if loop2=126 or loop2=38 or loop2=64 or loop2=37 or loop2=43 then
18370         remark nickname has a status prefix, separate the name and prefix
18380         ustat$(users) = user1$(1) : user$(users) = user1$(2 to len(user1$))
18390       else
18400         remark no status prefix
18410         ustat$(users) = "" : user$(users) = user1$
18420       end if
18430       if spc < len(who$) then who$=who$(spc+1 to len(who$)) : else who$ = ""
18440     end if
18450     users = users + 1 : remark one more user added to the list
18460   end rep loop2
18470 end def RPL_NamReply
18480 :
18490 def proc RPL_Topic
18500   remark RPL_TOPIC  :sender 332 target_nickname #QLForum :topic_text
18510   remark Channel Topic of the day message
18520   w = ':' instr parameter$
18530   topic$ = "" : remark the current topic for this channel
18540   if w < len(parameter$) then
18550     topic$ = parameter$(w+1 to len(parameter$))
18560 remark    ink #chat_chan%,chat_ink3%
18570     Wrap #chat_chan%,69,69,chat_ink3%,topic$
18580     ink #chat_chan%,chat_ink1%
18590     Log topic$
18600   end if
18610 end def RPL_Topic
18620 :
18630 def proc RPL_TopicWhoTime
18640   remark RPL_TOPICWHOTIME - topic was set by who and when?
18650   remark :sender 333 target_nickname #QLForum set_by_nickname time_string
18660   remark time_string is Unix format, 0=start of 1970
18670   remark QL DATE 0=start of 1961 (difference of 283,996,800 seconds)
18680   remark first, remove the target_nickname (i.e. my nickname)
18690   w = " " instr parameter$ : remark space after target nickname
18700   parameter$ = parameter$(w+1 to len(parameter$))
18710   remark remove the channel name (#QLForum)
18720   w = " " instr parameter$ : remark space after #QLForum
18730   parameter$ = parameter$(w+1 to len(parameter$))
18740   remark get the nickname of person who set the topic
18750   w = " " instr parameter$
18760   who$ = parameter$(1 to w-1)
18770   parameter$ = parameter$(w+1 to len(parameter$))
18780   remark get the time string
18790   timestamp = "0"&parameter$
18800 remark   ink #chat_chan%,chat_ink3%
18810   Wrap #chat_chan%,69,69,chat_ink3%,"Topic set by "&who$&" "&date$(timestamp+283996800)
18820   ink #chat_chan%,chat_ink1%
18830   Log "Topic set by "&who$&" "&date$(timestamp+283996800) : Log ""
18840 end def RPL_TopicWhoTime
18850 :
18860 def proc Help_Text
18870   remark /HELP command displays a list of /COMMANDS supported.
18880   remark Although shown in upper case, they are not case-sensitive.
18890   ink #chat_chan%,chat_ink3%
18900   print #chat_chan%,
18910   print #chat_chan%,"/AWAY [message] - Declare yourself 'away'."
18920   print #chat_chan%,"/BACK           - Declare yourself 'back' (or /AWAY with no message)."
18930   print #chat_chan%,"/EXIT           - Leave IRC channel and stop QLirc."
18940   print #chat_chan%,"/JOIN chan [key]- join given channel, specifying optional key."
18950   print #chat_chan%,"/LIST [channel] - List channels + topics on (optional) target server."
18960   print #chat_chan%,"/LOG [filename] - Start the session (no filename=stop logging)."
18970   print #chat_chan%,"/ME action      - Action message (/me is replaced by my nickname)."
18980   print #chat_chan%,"/MODE parameters- Set user modes, see RFC 2812."
18990   print #chat_chan%,"/MSG name msg   - Send private message to someone."
19000   print #chat_chan%,"/NAMES          - Request new list of nicknames from server."
19010   print #chat_chan%,"/NICK new_name  - Change my nickname."
19020   print #chat_chan%,"/OPER name pass - Request operator privileges (password needed)."
19030   print #chat_chan%,"/PART [channel] - Depart from IRC channel (no name=current channel)."
19040   print #chat_chan%,"/QUERY nickname - Send future messages only to 'nickname' as Private"\ to 18;"Messages (cancel with /QUERY)."
19050   print #chat_chan%,"/QUIT [message] - Terminate client session with optional message."
19060   print #chat_chan%,"/TOPIC #channel [:message] - set new topic for the given channel."
19070   print #chat_chan%,to 18;"/TOPIC #channel = read, /TOPIC #channel : = clear."
19080   print #chat_chan%,
19090   ink #chat_chan%,chat_ink3%
19100 end def Help_Text
